//
//  Copyright (c) 2004 Nat!
//  All rights reserved.
//
//  A Mulle kybernetiK production
//  www.mulle-kybernetik.com
//
#import "MulleHostCheckStatusMenuExtra.h"
#import "MulleHostCheckStatusView.h"
#import "MulleHostCheck.h"
#import "LEDImagePainter.h"

#import <Carbon/Carbon.h>


@implementation MulleHostCheckStatusMenuExtra

- initWithBundle:(NSBundle *) bundle 
{
   SInt32    systemVersion;
   NSRect    frame;
   
   NSLog( @"MulleHostCheck MenuExtra loading...");

   self = [super initWithBundle:bundle];
   if( ! self) 
      return nil;
   
   // Panther check
   Gestalt( gestaltSystemVersion, &systemVersion);
   isPanther = systemVersion >= 0x1030;
   // Setup our menu
   theMenu = [[NSMenu alloc] initWithTitle:@""];
   [theMenu setAutoenablesItems:NO];

   NSLog( @"0");
   painter = [[LEDImagePainter alloc] initWithBundle:bundle];
   NSLog( @"1");
   check   = [[MulleHostCheck alloc] init];
   NSLog( @"2");
   [self imagePaint];
   NSLog( @"3");
   
   frame.origin = NSZeroPoint;
   frame.size   = [image size];
   theView = [[MulleHostCheckStatusView alloc] initWithFrame:frame
                                                menuExtra:self];
   [self setView:theView];

   theMainTimer = [[NSTimer scheduledTimerWithTimeInterval:(NSTimeInterval) 4.0 // alle 4 sec
                                                    target:self 
                                                  selector:@selector( updateDisplay)
                                                  userInfo:nil
                                                   repeats:YES] retain];
   
   [check run];
   NSLog( @"MulleHostCheck MenuExtra loaded");
   [self updateDisplay];
   return( self);
}


- (void) dealloc 
{
   [self shutdown];

   [theMainTimer release];
   [check release];
   [theView release];
   [theMenu release];
   [painter release];
   [image release];
   
   [super dealloc];
}


- (void) shutdown
{
   [theMainTimer invalidate];
   [theEventLoopTimer invalidate];
}


- (void) willUnload 
{
   [self shutdown];
	
   [super willUnload];
} 

- (unsigned int) length
{
   if( length < 0.1)
      [self imagePaint];
   NSLog( @"length: %f", length);
   return( length);
}
  

- (NSImage *) image 
{
   if( ! image)
      [self imagePaint];
   return( image);
} 


- (void) clickOnMenuItem:(id) sender
{
   // do something
}


- (NSMenu *) menu 
{
   NSMenuItem     *item;
   unsigned int   i, n;
   NSString       *name;
   BOOL           flag;
   
   // Clear out the menu
   while( [theMenu numberOfItems]) 
      [theMenu removeItemAtIndex:0];

   n = [check count];
   for( i = 0; i < n; i++)
   {
      name = [check hostNameAtIndex:i];
      flag = [check isUpAtIndex:i];
      
      NSLog( @"Adding %@ with state %s", name, flag ? "ON" : "OFF");
      
      item = (NSMenuItem *) [theMenu addItemWithTitle:name
                                               action:@selector( clickOnMenuItem:) 
                                        keyEquivalent:@""];
      [item setTarget:self];
      [item setEnabled:flag];
     
//      [theMenuItem setImage:[volDict objectForKey:@"menuitemimage"]];
//     [theMenuItem setRepresentedObject:];
   } // end of array details enumeration
   
   // Send the menu back to SystemUIServer
   return( theMenu);
} 


- (void) render
{
   unsigned int   i, n;
   BOOL           *array;
   
   n     = [check count];
   array = alloca( sizeof( BOOL) * n);
   
   for( i = 0; i < n; i++)
      array[ i] = [check isUpAtIndex:i];
   
   [painter setBoolArray:array
                  length:n];
}


- (void) imagePaint
{
   float  width;
   
   [self render];
   [image release];
   image = [[painter image] retain];
   width = [image size].width;
   if( width != length)
   {
      NSLog( @"Adjust width to %f", width);
      length = width;
      [self _adjustLength];
   }
}


- (void) updateDisplay 
{
   [self imagePaint];
   [theView setNeedsDisplay:YES];
      
      // If the menu is down force it to update too
   if ([self isMenuDown]) 
      [self updateMenuWhenDown];
}


- (void) updateMenuWhenDown 
{
   MenuRef   carbonMenu;
   
   // If no menu items are currently live, do nothing
   if( ! updateMenuItems) 
      return;
   
   // Get the Carbon menu ref
   // From example code posted by Dustin Voss to the Apple Cocoa-Dev list
   // http://cocoa.mamasam.com/COCOADEV/2002/09/2/45220.php 
   carbonMenu = _NSGetCarbonMenu(theMenu);
   // Force the menu to redraw
   UpdateInvalidMenuItems( carbonMenu);
   
} 


@end